﻿unit legendWin;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, RejbrandCommon;

type
  TfrmLegend = class(TForm)
    procedure FormPaint(Sender: TObject);
    procedure FormResize(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmLegend: TfrmLegend;

implementation

uses Types, Math, LorenzSystem;

{$R *.dfm}

procedure TfrmLegend.FormPaint(Sender: TObject);
var
  HueStep: TASR;
  clr: THSV;
  x: integer;
  BM: TBitmap;
  R: TRect;
  TW: integer;

const
  SAtZero = 'Speed = 0';
  SAboveLimit = 'Speed ≥ 500';
  SAtLimit = 'Speed = 500';
begin

  Assert(VMAX = 500);

  HueStep := 360 / ClientWidth;

  clr := RejbrandCommon.HSV(240, 1, 1);

  BM := TBitmap.Create;
  try
    BM.SetSize(ClientWidth, ClientHeight);

    with BM.Canvas do
    begin
      Brush.Color := Color;
      FillRect(ClientRect);
      Pen.Style := psSolid;
      Pen.Mode := pmCopy;
      for x := 0 to Width - 1 do
      begin
        Pen.Color := GetPascalColor(clr);
        MoveTo(x, 0);
        LineTo(x, ClientHeight - 64);
        clr.hsvHue := Max(clr.hsvHue - HueStep, 0);
      end;

      Pen.Color := clWhite;
      MoveTo(0, 0);
      LineTo(0, ClientHeight - 40);
      LineTo(8, ClientHeight - 32);
      MoveTo(round(240/HueStep), 0);
      LineTo(round(240/HueStep), ClientHeight - 32);

      Font.Assign(Self.Font);
      R := Rect(8, ClientHeight - 32, ClientWidth, ClientHeight);
      DrawText(Handle, SAtZero, -1, R, DT_SINGLELINE or DT_VCENTER or DT_LEFT);
      R := Rect(round(240/HueStep) + 8, ClientHeight - 64, ClientWidth, ClientHeight - 32);
      DrawText(Handle, SAboveLimit, -1, R, DT_SINGLELINE or DT_VCENTER or DT_LEFT);
      TW := TextWidth(SAtLimit);
      R := Rect(round(240/HueStep) - TW, ClientHeight - 32, round(240/HueStep) + TW, ClientHeight);
      DrawText(Handle, SAtLimit, -1, R, DT_SINGLELINE or DT_VCENTER or DT_CENTER)

    end;

    Canvas.Draw(0, 0, BM);
  finally
    BM.Free;
  end;

end;

procedure TfrmLegend.FormResize(Sender: TObject);
begin
  Invalidate;
end;

end.
